;
;   Emacs like bindings for Jed.
;
;  The default keybindings for Jed use ^W, ^F, and ^K keymaps.  Emacs
;  does not bind these so turn them off
"emacs.hlp" =Help_File

"^K"    unsetkey
"^W"    unsetkey
"^F"    unsetkey

;  Jed default binding of the tab char ^I is to indent line.  Here just insert
;  the tab

;;	"self_insert_cmd"	"^I"   setkey

;;	"backward_delete_char"	"^?"   setkey
	"backward_delete_char_untabify"	"^?"   setkey
	"bol"			"^A"   setkey
	"previous_char_cmd"	"^B"   setkey
	"delete_char_cmd"	"^D"   setkey
	"eol_cmd"		"^E"   setkey
	"next_char_cmd"		"^F"   setkey
	"newline_and_indent"	"^J"   setkey
	"kill_line"		"^K"   setkey
	"emacs_recenter"	"^L"   setkey
	"newline_and_indent"	"^M"   setkey
	;;"newline"		"^M"   setkey
	"next_line_cmd"		"^N"   setkey
	"previous_line_cmd"	"^P"   setkey
	"quoted_insert"		"^Q"   setkey
;;
;;  Try these if you prefer
;;      "isearch_backward"	"^R"   setkey
;;      "isearch_forward"	"^S"   setkey
;;
	"search_backward"	"^R"   setkey
	"search_forward"	"^S"   setkey
	"page_down"		"^V"   setkey
	"kill_region"		"^W"   setkey
	"yank"			"^Y"   setkey
	"sys_spawn_cmd"		"^Z"   setkey
;
;                   The escape map
;
	"bskip_word"		"^[b"	setkey
	"delete_word"		"^[d"	setkey
	"skip_word"		"^[f"	setkey
	"replace"		"^[%"	setkey
	"bob"			"^[<"	setkey
	"eob"			"^[>"	setkey
	"narrow_paragraph"	"^[N"	setkey
	"format_paragraph"	"^[Q"	setkey
	"page_up"		"^[V"	setkey
	"copy_region"		"^[W"	setkey
	"evaluate_cmd"		"^[X"	setkey
	"trim_whitespace"	"^[\\"	setkey
;
;    ^X map
;
        "whatpos"               "^X="   setkey
	"begin_macro"		"^X("	setkey
	"end_macro"		"^X)"	setkey
	"mark_spot"		"^X/"	setkey
	"one_window"		"^X1"	setkey
	"split_window"		"^X2"	setkey
	"scroll_left"		"^X<"	setkey
	"scroll_right"		"^X>"	setkey
	"switch_to_buffer"	"^XB"	setkey
	"insert_file"		"^XI"	setkey
	"execute_macro"		"^XE"	setkey
	"pop_spot"		"^XJ"	setkey
	"kill_buffer"		"^XK"	setkey
	"other_window"		"^XO"	setkey
	"exit_jed"		"^X^C"	setkey
	"find_file"		"^X^F"	setkey
	"toggle_readonly"	"^X^Q"	setkey
	"write_buffer"		"^X^S"	setkey
	"transpose_lines"	"^X^T"	setkey
	"write_buffer"		"^X^W"	setkey

;  On the IBM PC, the ^@ is an extended key like all the arrow keys.  The
;  default Jed bindings enable all these keys including the ^@.  See source
;  for details.

"_IBMPC" defined?
        {"set_mark_cmd"		"^@^C"	setkey}
        {"set_mark_cmd"		"^@"	setkey}
    else

0 9 1 { "^U" exch string strcat "digit_arg" exch setkey } for

;; misc functions

( eob push_mark bob ) emacs_mark_buffer  "emacs_mark_buffer" "^XH" setkey
( newline 1 left pop ) emacs_open_line "emacs_open_line" "^O" setkey
( 0 recenter "redraw" call) emacs_recenter
