;;
;;  utility functions which Must be available (e.g., autoload)
;;

;;
;;  A routine that trims the buffer by:  removing excess whitespace at the
;;  end of lines and removing excess newlines
;;

(
  push_spot
  bob
  {1} {
	eol trim bol
	eolp {
	  1 down pop
	  { {eol trim bol eolp } {eobp 0 ==} andelse } { del } while
	} if
	1 down {break} !if
      } while
  bob eol trim bol eolp {del} if
  pop_spot  "done." message
) trim_buffer

(
   getbuf_info
   1 xor setbuf_info
) tog_bufmod

;; occur function
;;
(
  [str cbuf tmp]  ;; local variables
  "Find All:" "" "" read_mini =str
  "*occur*" =tmp whatbuf =cbuf
  tmp bufferp { tmp delbuf } if
  push_spot
  {str fsearch}
    {
       whatline string
       push_mark
       narrow
       tmp setbuf
       insert 5 goto_column ":"  insert
       cbuf insbuf newline
       cbuf setbuf
       widen
       eol             ;; so we do not find another occurance on same line
    } while
    pop_spot
    ;; did we make it
    tmp bufferp { tmp pop2buf bob 0 set_buffer_modified_flag} if
) occur

