;
;  Example of menus for JED.  This is designed to aid in learning
;  the editor since after a menu item has been chosen, the user is 
;  informed of the keybinding of the function.
;


(
  [list] =list
  [i cmd] 0 =i
  [s] Null_String =s
  
  {
     list i ',' extract_element =cmd
     
     cmd strlen {break} !if
     i {s ", " strcat =s} if
     s 
     "(" i string strcat ")" strcat
     cmd strcat
     strcat =s
     ++i
   } forever
   
   s
) menu_build_display_string

( [list] =list
  [i] 
  0 =i
  { list i ',' extract_element strlen {break} !if
    ++i
  } forever
  i 1 -
) menu_list_length

[Menu_Last_Cmd]

(
  [cmd_list] [s_list] =cmd_list =s_list
  [cmd i s n] 0 =i
  
  s_list menu_list_length =n
  
  "Menu: "
  s_list menu_build_display_string 
  strcat =s
  
  
  {
    s flush
    getkey =i
    i 7 == {"kbd_quit" call} if
    
    '0' -=i
  
    i 0 >= 
    i n <=
    and {break} if
    
    beep 
    {0 input_pending}{getkey pop} while
    "Pick a number or press Control-G to abort!" flush
    2 input_pending pop
  } forever
  
  cmd_list i ',' extract_element =cmd
  
  cmd 1 1 substr int '@' ==
    {
       cmd 2 cmd strlen substr =Menu_Last_Cmd Menu_Last_Cmd call
    }{ cmd =Menu_Last_Cmd cmd eval}
  else
  
) menu_select_cmd

(
  "One window,Split Window,Other Window,Redraw"
  "@one_window,@split_window,@other_window,@redraw"
  menu_select_cmd
) menu_window_cmds

(
  "Search Forward,Search Backward,Replace"
  "@search_forward,@search_backward,@replace"
  menu_select_cmd
) search_replace


(
  "Begin Region,Cut Region,Copy Region,Paste"
  "@set_mark_cmd,@kill_region,@copy_region,@yank"
  menu_select_cmd
) menu_cut_paste


(
  "Page Up,Page Down,Top,Bottom,Page Left,Page Right"
  "@page_up,@page_down,@bob,@eob,@scroll_right,@scroll_left"
  menu_select_cmd
) menu_movement


( "Search/Replace,Moving around,Cut/Paste,Undo,Formatting"
  "search_replace,menu_movement,menu_cut_paste,@undo,@format_paragraph"
  menu_select_cmd 
) menu_basics

( 
  "Text Mode,C Mode,Fortran,Tog Overwrite,Tog readonly"
  "text_mode,c_mode,fortran,toggle_overwrite,toggle_readonly"
  menu_select_cmd
) menu_buffer_modes

( 
  "Kill Buffer,Switch To Buffer,List Buffers,Set buffer modes"
  "@kill_buffer,@switch_to_buffer,list_buffers,menu_buffer_modes"
  menu_select_cmd
) menu_buffers

( 
  "Read File,Write File,Save Buffers,Insert File"
  "@find_file,@write_buffer,@save_buffers,@insert_file"
  menu_select_cmd
) menu_files


(
  "Pop up help,Browse Documentation,Show Key"
  "help,info_run_info,showkey"
  menu_select_cmd
) menu_help

(
  "compose mail,send mail,ispell,shell command,Suspend"
  "mail,send,ispell,do_shell_cmd,@sys_spawn_cmd"
  menu_select_cmd
) menu_misc

( [key] =key
  [n str] key strlen =n
  [i ch key_string] 1 =i Null_String =key_string
  
  {i n <=}
  {
     key i 1 substr int =ch
     ++i
     ch {'^' == i n <= and :  ;; control char
          ;; common cases are '^[, ^[[?, ^[O?'
	  key i 3 substr =str
	  str int '[' == 
	  {
	     3 +=i
	     str { "[[A" strcmp not : "UP" }
	         { "[[B" strcmp not : "DOWN" }
		 { "[[C" strcmp not : "RIGHT" }
		 { "[[D" strcmp not : "LEFT" }
		 { "[OP" strcmp not : "GOLD" }
		 { "[OA" strcmp not : "UP" }
		 { "[OB" strcmp not : "DOWN" }
		 { "[OC" strcmp not : "RIGHT" }
		 { "[OD" strcmp not : "LEFT" }
		 { pop "ESC" 2 -=i}
	       switch
	  }{
	     ++i
	     "Control-" str int char strcat
	  } else
	}{ char } 
      switch
      key_string exch strcat " " strcat =key_string
    } while
  key_string
) menu_expand_keystring


(
  [n key len next nlen]
  "Basic,Files,Buffers,Windows,Help,Misc,Exit"
  "menu_basics,menu_files,menu_buffers,menu_window_cmds,menu_help,menu_misc,@exit_jed"
  menu_select_cmd
  
  Menu_Last_Cmd which_key =n
  n { 
      =key --n
      key strlen =len
      n {
          =next
	  next strlen =nlen
	  nlen len < { nlen =len next =key } if
        } loop
	
     "Function is on key " key menu_expand_keystring strcat
    }
    {"Not on any keys."}
  else
  message

) menu_main_cmds  

