;;
;;  Recall previous commands in MiniBuffer
;;

[Prev_Minibuffer] " *mini*" =Prev_Minibuffer
[In_Mini_Flag] 0 =In_Mini_Flag

Prev_Minibuffer bufferp 
{ whatbuf 
;; to minimize fragmentation, alloc 16 lines now
   Prev_Minibuffer setbuf
   60 {" " insert} loop  ;; 60 chars is probably ok
   15 {double_line} loop
   bob
  setbuf
} !if

(
  bol eobp {return} if
  push_mark eol bufsubstr
  " <mini>" setbuf
  bol push_mark eol del_region
  insert trim
) mini_use_this_line

(
   Prev_Minibuffer setbuf
   In_Mini_Flag {1 down {"End of list" message beep return} !if}
                { 1 =In_Mini_Flag eob }
	      else
   bol
   mini_use_this_line
) next_mini_command

(
   Prev_Minibuffer setbuf
   In_Mini_Flag { 1 up {"Top of List." message beep return} !if }
                { 1 =In_Mini_Flag eob }
	      else
   bol
   mini_use_this_line
) prev_mini_command

(
   bol skip_white
   eolp
     {
        bol push_mark eol bufsubstr
	Prev_Minibuffer setbuf
	bob push_mark eol 1 right pop del_region ;; lose one off top
	eob newline
	insert bol 
	60 60 right - {" " insert} loop  ;; keep 60 chars
	" <mini>" setbuf                      ;; to avoid fragmentation
     } !if
   "exit_mini" call
   0 =In_Mini_Flag
) mini_exit_minibuffer



