;; system specific routines

#VMS
(
  [cfile file cmd] 
  "@jed_library:vms_shell.com/output=" =cfile
  "sys$login:_jed_shell.cmd_" =file
  cfile file strcat =cfile
  
  "Shell Command:"  "" "" read_mini =cmd
  cmd strlen {return} !if
  
  " \"" cmd strcat "\"" strcat =cmd
  "starting process..." flush
  cfile cmd strcat system pop
  "*shell*" pop2buf erase_buffer
  file insert_file pop bob
  file delete_file
) do_shell_cmd
#end VMS

#IBMPC
;; ibmpc.sl
;; system specific routines

(
  [file cmd] "_jed_shll.cmd" =file
  "Shell Command:"  "" "" read_mini =cmd 
  cmd strlen {return} !if
  
  cmd " > " strcat file strcat =cmd
  "opening pipe..." flush
  cmd system pop
  "*shell-output*" pop2buf erase_buffer
  file insert_file pop bob
  file delete_file
  "" message
) do_shell_cmd

#end IBMPC

#UNIX
(
   [msg shbuf cmd] "*shell-output*" =shbuf "opening pipe..." =msg
   "Shell Command:"  "" "" read_mini =cmd
   cmd strlen { return } !if
   cmd " 2>&1" strcat =cmd
   shbuf pop2buf erase_buffer
   msg flush
   cmd shell_cmd bob
   msg "done" strcat flush
) do_shell_cmd 
#end UNIX

(
  [km]  "*shell*" =km

  km keymap_p { 
    km make_keymap
    "shell_input" "^M" km definekey
  } !if
  
  km pop2buf
  km use_keymap
#UNIX
   "% " insert
#end
#IBMPC
   "> " insert
#end
#VMS
   "$ " insert
#end
) shell


(
   [cmd tmp prompt]
#UNIX
   "% " =prompt "/tmp/_jed_shell_" =tmp
#end
#IBMPC
   "> " =prompt "jedshell.jed" =tmp
#end
#VMS
   "$ " =prompt "sys$login:_jed_shell_.jed_" =tmp
#end
  
   
   bol prompt skip_chars
   push_mark eol bufsubstr =cmd
   eob bol prompt skip_chars
   cmd looking_at {cmd insert} !if
   eol newline
   update  ;; Update now so user see that things are ok
   
   cmd strlen {
#UNIX
                "( " cmd strcat ")" strcat 
		" > " strcat tmp strcat " 2>&1" strcat
#end
#IBMPC
                cmd " > " strcat tmp strcat 
#end
#VMS
               "@" "JED_LIBRARY" getenv strcat
	       "vms_shell/output=" strcat tmp strcat
	       " " strcat cmd strcat 
#end
     system
     tmp insert_file pop
     tmp delete_file pop
   } if
   
   bolp {prompt}{"\n" prompt strcat} else insert
) shell_input

